<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ZKDatabase.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">ZKDatabase.java</span></div><h1>ZKDatabase.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collection;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.locks.ReentrantReadWriteLock;
import java.util.concurrent.locks.ReentrantReadWriteLock.ReadLock;
import java.util.concurrent.locks.ReentrantReadWriteLock.WriteLock;

import org.apache.jute.BinaryOutputArchive;
import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.apache.jute.Record;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.KeeperException.NoNodeException;
import org.apache.zookeeper.Watcher;
import org.apache.zookeeper.data.ACL;
import org.apache.zookeeper.data.Stat;
import org.apache.zookeeper.server.DataTree.ProcessTxnResult;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog.PlayBackListener;
import org.apache.zookeeper.server.quorum.Leader;
import org.apache.zookeeper.server.quorum.Leader.Proposal;
import org.apache.zookeeper.server.quorum.QuorumPacket;
import org.apache.zookeeper.server.util.SerializeUtils;
import org.apache.zookeeper.txn.TxnHeader;

/**
 * This class maintains the in memory database of zookeeper
 * server states that includes the sessions, datatree and the
 * committed logs. It is booted up  after reading the logs
 * and snapshots from the disk.
 */
public class ZKDatabase {
    
<span class="fc" id="L61">    private static final Logger LOG = LoggerFactory.getLogger(ZKDatabase.class);</span>
    
    /**
     * make sure on a clear you take care of 
     * all these members.
     */
    protected DataTree dataTree;
    protected ConcurrentHashMap&lt;Long, Integer&gt; sessionsWithTimeouts;
    protected FileTxnSnapLog snapLog;
    protected long minCommittedLog, maxCommittedLog;
    public static final int commitLogCount = 500;
<span class="fc" id="L72">    protected static int commitLogBuffer = 700;</span>
<span class="fc" id="L73">    protected LinkedList&lt;Proposal&gt; committedLog = new LinkedList&lt;Proposal&gt;();</span>
<span class="fc" id="L74">    protected ReentrantReadWriteLock logLock = new ReentrantReadWriteLock();</span>
<span class="fc" id="L75">    volatile private boolean initialized = false;</span>
    
    /**
     * the filetxnsnaplog that this zk database
     * maps to. There is a one to one relationship
     * between a filetxnsnaplog and zkdatabase.
     * @param snapLog the FileTxnSnapLog mapping this zkdatabase
     */
<span class="fc" id="L83">    public ZKDatabase(FileTxnSnapLog snapLog) {</span>
<span class="fc" id="L84">        dataTree = new DataTree();</span>
<span class="fc" id="L85">        sessionsWithTimeouts = new ConcurrentHashMap&lt;Long, Integer&gt;();</span>
<span class="fc" id="L86">        this.snapLog = snapLog;</span>
<span class="fc" id="L87">    }</span>
    
    /**
     * checks to see if the zk database has been
     * initialized or not.
     * @return true if zk database is initialized and false if not
     */
    public boolean isInitialized() {
<span class="fc" id="L95">        return initialized;</span>
    }
    
    /**
     * clear the zkdatabase. 
     * Note to developers - be careful to see that 
     * the clear method does clear out all the
     * data structures in zkdatabase.
     */
    public void clear() {
<span class="fc" id="L105">        minCommittedLog = 0;</span>
<span class="fc" id="L106">        maxCommittedLog = 0;</span>
        /* to be safe we just create a new 
         * datatree.
         */
<span class="fc" id="L110">        dataTree = new DataTree();</span>
<span class="fc" id="L111">        sessionsWithTimeouts.clear();</span>
<span class="fc" id="L112">        WriteLock lock = logLock.writeLock();</span>
        try {            
<span class="fc" id="L114">            lock.lock();</span>
<span class="fc" id="L115">            committedLog.clear();</span>
<span class="fc" id="L116">        } finally {</span>
<span class="nc" id="L117">            lock.unlock();</span>
<span class="fc" id="L118">        }</span>
<span class="fc" id="L119">        initialized = false;</span>
<span class="pc" id="L120">    }</span>
    
    /**
     * the datatree for this zkdatabase
     * @return the datatree for this zkdatabase
     */
    public DataTree getDataTree() {
<span class="fc" id="L127">        return this.dataTree;</span>
    }
 
    /**
     * the committed log for this zk database
     * @return the committed log for this zkdatabase
     */
    public long getmaxCommittedLog() {
<span class="fc" id="L135">        return maxCommittedLog;</span>
    }
    
    
    /**
     * the minimum committed transaction log
     * available in memory
     * @return the minimum committed transaction
     * log available in memory
     */
    public long getminCommittedLog() {
<span class="fc" id="L146">        return minCommittedLog;</span>
    }
    /**
     * Get the lock that controls the committedLog. If you want to get the pointer to the committedLog, you need
     * to use this lock to acquire a read lock before calling getCommittedLog()
     * @return the lock that controls the committed log
     */
    public ReentrantReadWriteLock getLogLock() {
<span class="fc" id="L154">        return logLock;</span>
    }
    

    public synchronized LinkedList&lt;Proposal&gt; getCommittedLog() {
<span class="fc" id="L159">        ReadLock rl = logLock.readLock();</span>
        // only make a copy if this thread isn't already holding a lock
<span class="fc bfc" id="L161" title="All 2 branches covered.">        if(logLock.getReadHoldCount() &lt;=0) {</span>
            try {
<span class="fc" id="L163">                rl.lock();</span>
<span class="fc" id="L164">                return new LinkedList&lt;Proposal&gt;(this.committedLog);</span>
            } finally {
<span class="nc" id="L166">                rl.unlock();</span>
            }
        } 
<span class="pc" id="L169">        return this.committedLog;</span>
    }      
    
    /**
     * get the last processed zxid from a datatree
     * @return the last processed zxid of a datatree
     */
    public long getDataTreeLastProcessedZxid() {
<span class="fc" id="L177">        return dataTree.lastProcessedZxid;</span>
    }
    
    /**
     * set the datatree initialized or not
     * @param b set the datatree initialized to b
     */
    public void setDataTreeInit(boolean b) {
<span class="fc" id="L185">        dataTree.initialized = b;</span>
<span class="fc" id="L186">    }</span>
    
    /**
     * return the sessions in the datatree
     * @return the data tree sessions
     */
    public Collection&lt;Long&gt; getSessions() {
<span class="fc" id="L193">        return dataTree.getSessions();</span>
    }
    
    /**
     * get sessions with timeouts
     * @return the hashmap of sessions with timeouts
     */
    public ConcurrentHashMap&lt;Long, Integer&gt; getSessionWithTimeOuts() {
<span class="fc" id="L201">        return sessionsWithTimeouts;</span>
    }

    
    /**
     * load the database from the disk onto memory and also add 
     * the transactions to the committedlog in memory.
     * @return the last valid zxid on disk
     * @throws IOException
     */
    public long loadDataBase() throws IOException {
<span class="fc" id="L212">        PlayBackListener listener=new PlayBackListener(){</span>
            public void onTxnLoaded(TxnHeader hdr,Record txn){
<span class="fc" id="L214">                Request r = new Request(null, 0, hdr.getCxid(),hdr.getType(),</span>
                        null, null);
<span class="fc" id="L216">                r.txn = txn;</span>
<span class="fc" id="L217">                r.hdr = hdr;</span>
<span class="fc" id="L218">                r.zxid = hdr.getZxid();</span>
<span class="fc" id="L219">                addCommittedProposal(r);</span>
<span class="fc" id="L220">            }</span>
        };
        
<span class="fc" id="L223">        long zxid = snapLog.restore(dataTree,sessionsWithTimeouts,listener);</span>
<span class="fc" id="L224">        initialized = true;</span>
<span class="fc" id="L225">        return zxid;</span>
    }
    
    /**
     * maintains a list of last &lt;i&gt;committedLog&lt;/i&gt;
     *  or so committed requests. This is used for
     * fast follower synchronization.
     * @param request committed request
     */
    public void addCommittedProposal(Request request) {
<span class="fc" id="L235">        WriteLock wl = logLock.writeLock();</span>
        try {
<span class="fc" id="L237">            wl.lock();</span>
<span class="fc bfc" id="L238" title="All 2 branches covered.">            if (committedLog.size() &gt; commitLogCount) {</span>
<span class="fc" id="L239">                committedLog.removeFirst();</span>
<span class="fc" id="L240">                minCommittedLog = committedLog.getFirst().packet.getZxid();</span>
            }
<span class="fc bfc" id="L242" title="All 2 branches covered.">            if (committedLog.size() == 0) {</span>
<span class="fc" id="L243">                minCommittedLog = request.zxid;</span>
<span class="fc" id="L244">                maxCommittedLog = request.zxid;</span>
            }

<span class="fc" id="L247">            ByteArrayOutputStream baos = new ByteArrayOutputStream();</span>
<span class="fc" id="L248">            BinaryOutputArchive boa = BinaryOutputArchive.getArchive(baos);</span>
            try {
<span class="fc" id="L250">                request.hdr.serialize(boa, &quot;hdr&quot;);</span>
<span class="fc bfc" id="L251" title="All 2 branches covered.">                if (request.txn != null) {</span>
<span class="fc" id="L252">                    request.txn.serialize(boa, &quot;txn&quot;);</span>
                }
<span class="fc" id="L254">                baos.close();</span>
<span class="nc" id="L255">            } catch (IOException e) {</span>
<span class="nc" id="L256">                LOG.error(&quot;This really should be impossible&quot;, e);</span>
<span class="fc" id="L257">            }</span>
<span class="fc" id="L258">            QuorumPacket pp = new QuorumPacket(Leader.PROPOSAL, request.zxid,</span>
<span class="fc" id="L259">                    baos.toByteArray(), null);</span>
<span class="fc" id="L260">            Proposal p = new Proposal();</span>
<span class="fc" id="L261">            p.packet = pp;</span>
<span class="fc" id="L262">            p.request = request;</span>
<span class="fc" id="L263">            committedLog.add(p);</span>
<span class="fc" id="L264">            maxCommittedLog = p.packet.getZxid();</span>
<span class="fc" id="L265">        } finally {</span>
<span class="nc" id="L266">            wl.unlock();</span>
<span class="fc" id="L267">        }</span>
<span class="pc" id="L268">    }</span>

    
    /**
     * remove a cnxn from the datatree
     * @param cnxn the cnxn to remove from the datatree
     */
    public void removeCnxn(ServerCnxn cnxn) {
<span class="fc" id="L276">        dataTree.removeCnxn(cnxn);</span>
<span class="fc" id="L277">    }</span>

    /**
     * kill a given session in the datatree
     * @param sessionId the session id to be killed
     * @param zxid the zxid of kill session transaction
     */
    public void killSession(long sessionId, long zxid) {
<span class="nc" id="L285">        dataTree.killSession(sessionId, zxid);</span>
<span class="nc" id="L286">    }</span>

    /**
     * write a text dump of all the ephemerals in the datatree
     * @param pwriter the output to write to
     */
    public void dumpEphemerals(PrintWriter pwriter) {
<span class="fc" id="L293">        dataTree.dumpEphemerals(pwriter);</span>
<span class="fc" id="L294">    }</span>

    /**
     * the node count of the datatree
     * @return the node count of datatree
     */
    public int getNodeCount() {
<span class="fc" id="L301">        return dataTree.getNodeCount();</span>
    }

    /**
     * the paths for  ephemeral session id 
     * @param sessionId the session id for which paths match to 
     * @return the paths for a session id
     */
    public HashSet&lt;String&gt; getEphemerals(long sessionId) {
<span class="fc" id="L310">        return dataTree.getEphemerals(sessionId);</span>
    }

    /**
     * the last processed zxid in the datatree
     * @param zxid the last processed zxid in the datatree
     */
    public void setlastProcessedZxid(long zxid) {
<span class="fc" id="L318">        dataTree.lastProcessedZxid = zxid;</span>
<span class="fc" id="L319">    }</span>

    /**
     * the process txn on the data
     * @param hdr the txnheader for the txn
     * @param txn the transaction that needs to be processed
     * @return the result of processing the transaction on this
     * datatree/zkdatabase
     */
    public ProcessTxnResult processTxn(TxnHeader hdr, Record txn) {
<span class="fc" id="L329">        return dataTree.processTxn(hdr, txn);</span>
    }

    /**
     * stat the path 
     * @param path the path for which stat is to be done
     * @param serverCnxn the servercnxn attached to this request
     * @return the stat of this node
     * @throws KeeperException.NoNodeException
     */
    public Stat statNode(String path, ServerCnxn serverCnxn) throws KeeperException.NoNodeException {
<span class="fc" id="L340">        return dataTree.statNode(path, serverCnxn);</span>
    }
    
    /**
     * get the datanode for this path
     * @param path the path to lookup
     * @return the datanode for getting the path
     */
    public DataNode getNode(String path) {
<span class="fc" id="L349">      return dataTree.getNode(path);</span>
    }

    /**
     * convert from long to the acl entry
     * @param aclL the long for which to get the acl
     * @return the acl corresponding to this long entry
     */
    public List&lt;ACL&gt; convertLong(Long aclL) {
<span class="fc" id="L358">        return dataTree.convertLong(aclL);</span>
    }

    /**
     * get data and stat for a path 
     * @param path the path being queried
     * @param stat the stat for this path
     * @param watcher the watcher function
     * @return
     * @throws KeeperException.NoNodeException
     */
    public byte[] getData(String path, Stat stat, Watcher watcher) 
    throws KeeperException.NoNodeException {
<span class="fc" id="L371">        return dataTree.getData(path, stat, watcher);</span>
    }

    /**
     * set watches on the datatree
     * @param relativeZxid the relative zxid that client has seen
     * @param dataWatches the data watches the client wants to reset
     * @param existWatches the exists watches the client wants to reset
     * @param childWatches the child watches the client wants to reset
     * @param watcher the watcher function
     */
    public void setWatches(long relativeZxid, List&lt;String&gt; dataWatches,
            List&lt;String&gt; existWatches, List&lt;String&gt; childWatches, Watcher watcher) {
<span class="fc" id="L384">        dataTree.setWatches(relativeZxid, dataWatches, existWatches, childWatches, watcher);</span>
<span class="fc" id="L385">    }</span>
    
    /**
     * get acl for a path
     * @param path the path to query for acl
     * @param stat the stat for the node
     * @return the acl list for this path
     * @throws NoNodeException
     */
    public List&lt;ACL&gt; getACL(String path, Stat stat) throws NoNodeException {
<span class="fc" id="L395">        return dataTree.getACL(path, stat);</span>
    }

    /**
     * get children list for this path
     * @param path the path of the node
     * @param stat the stat of the node
     * @param watcher the watcher function for this path
     * @return the list of children for this path
     * @throws KeeperException.NoNodeException
     */
    public List&lt;String&gt; getChildren(String path, Stat stat, Watcher watcher)
    throws KeeperException.NoNodeException {
<span class="fc" id="L408">        return dataTree.getChildren(path, stat, watcher);</span>
    }

    /**
     * check if the path is special or not
     * @param path the input path
     * @return true if path is special and false if not
     */
    public boolean isSpecialPath(String path) {
<span class="fc" id="L417">        return dataTree.isSpecialPath(path);</span>
    }

    /**
     * get the acl size of the datatree
     * @return the acl size of the datatree
     */
    public int getAclSize() {
<span class="fc" id="L425">        return dataTree.longKeyMap.size();</span>
    }

    /**
     * Truncate the ZKDatabase to the specified zxid
     * @param zxid the zxid to truncate zk database to
     * @return true if the truncate is successful and false if not
     * @throws IOException
     */
    public boolean truncateLog(long zxid) throws IOException {
<span class="fc" id="L435">        clear();</span>

        // truncate the log
<span class="fc" id="L438">        boolean truncated = snapLog.truncateLog(zxid);</span>

<span class="pc bpc" id="L440" title="1 of 2 branches missed.">        if (!truncated) {</span>
<span class="nc" id="L441">            return false;</span>
        }

<span class="fc" id="L444">        loadDataBase();</span>
<span class="fc" id="L445">        return true;</span>
    }
    
    /**
     * deserialize a snapshot from an input archive 
     * @param ia the input archive you want to deserialize from
     * @throws IOException
     */
    public void deserializeSnapshot(InputArchive ia) throws IOException {
<span class="fc" id="L454">        clear();</span>
<span class="fc" id="L455">        SerializeUtils.deserializeSnapshot(getDataTree(),ia,getSessionWithTimeOuts());</span>
<span class="fc" id="L456">        initialized = true;</span>
<span class="fc" id="L457">    }   </span>
    
    /**
     * serialize the snapshot
     * @param oa the output archive to which the snapshot needs to be serialized
     * @throws IOException
     * @throws InterruptedException
     */
    public void serializeSnapshot(OutputArchive oa) throws IOException,
    InterruptedException {
<span class="fc" id="L467">        SerializeUtils.serializeSnapshot(getDataTree(), oa, getSessionWithTimeOuts());</span>
<span class="fc" id="L468">    }</span>

    /**
     * append to the underlying transaction log 
     * @param si the request to append
     * @return true if the append was succesfull and false if not
     */
    public boolean append(Request si) throws IOException {
<span class="fc" id="L476">        return this.snapLog.append(si);</span>
    }

    /**
     * roll the underlying log
     */
    public void rollLog() throws IOException {
<span class="fc" id="L483">        this.snapLog.rollLog();</span>
<span class="fc" id="L484">    }</span>

    /**
     * commit to the underlying transaction log
     * @throws IOException
     */
    public void commit() throws IOException {
<span class="fc" id="L491">        this.snapLog.commit();</span>
<span class="fc" id="L492">    }</span>
    
    /**
     * close this database. free the resources
     * @throws IOException
     */
    public void close() throws IOException {
<span class="fc" id="L499">        this.snapLog.close();</span>
<span class="fc" id="L500">    }</span>
    
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>